using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace GDBCFormulaColumn
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 64);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(552, 352);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(144, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(288, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "type an expression in the blue column";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(616, 446);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		

		private GridFormulaTag[] formulaTags;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					if( j == 1)
						dr[j] = "";
					else
						dr[j] = string.Format("row{0} col{1}", i, j);
				}
				dt.Rows.Add(dr);
			}

			//afoid complexities of allowing sorting or new rows
			dt.DefaultView.AllowNew = false;
			this.gridDataBoundGrid1.SortBehavior = GridSortBehavior.None;

			this.gridDataBoundGrid1.DataSource = dt;

			this.gridDataBoundGrid1.AllowResizeToFit = false;
			this.gridDataBoundGrid1.Model.ColWidths[2] = 130;

			this.gridDataBoundGrid1.Model.CellModels.Add("MyFormulaCell", new GridFormulaCellModel(this.gridDataBoundGrid1.Model, ' '));

			GridStyleInfo style = this.gridDataBoundGrid1.Binder.InternalColumns[1].StyleInfo;
			style.CellType = "MyFormulaCell";
			style.BackColor = Color.LightBlue;

			this.formulaTags = new GridFormulaTag[nRows];

			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(Model_QueryCellInfo);
			this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(Model_SaveCellInfo);
			this.gridDataBoundGrid1.CurrentCellValidating += new CancelEventHandler(gridDataBoundGrid1_CurrentCellValidating);
		}

		private void Model_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex == 2)
			{
				e.Style.FormulaTag = this.formulaTags[e.RowIndex - 1];
			}
		}

		private void Model_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex == 2)
			{
					this.formulaTags[e.RowIndex - 1] = e.Style.FormulaTag;
			}
		}

		private void gridDataBoundGrid1_CurrentCellValidating(object sender, CancelEventArgs e)
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			if(cc.RowIndex > 0 && cc.ColIndex == 2)
			{
				string val = cc.Renderer.ControlText;
				if(val.Length > 0 && val[0] != ' ')
					cc.Renderer.Control.Text = ' ' + val;
			}
		}
	}
}
